{Program dostosowany pod zadanie 2 lista 2.}
program BouncingBallSDL;
uses SDL, SDL_image, matrix, SysUtils;
const
   BackgroundFile = 'background.bmp';
   BallFile = 'ball.bmp';
var
   screen, background, ball : PSDL_Surface;
   
   procedure DrawBallOrShadow (shadow : Boolean;
                               const PixX, PixY : Integer);
   var
      SrcRect, DstRect : SDL_Rect;
   begin
      if (PixX >= 0) and (PixY >= 0)
         and (PixX + ball^.w < screen^.w) and (PixY + ball^.h < screen^.h)
      then begin
         with SrcRect do begin
            x := 0; y := 0; w := ball^.w; h := ball^.h
         end;
         with DstRect do begin
            x := PixX; y := PixY; w := PixX + ball^.w; h := PixY + ball^.h
         end;
         if shadow then begin
            if SDL_BlitSurface (background, @DstRect, screen, @DstRect) < 0
            then WriteLn ('BlitSurface shadow error : ', SDL_GetError)
         end else begin
            if SDL_BlitSurface (ball, @SrcRect, screen, @DstRect) < 0
            then WriteLn ('BlitSurface ball error : ', SDL_GetError)
         end
      end
   end;
   
   function Quitted : Boolean;
   var event : TSDL_Event;
   begin
      Quitted := False;
      while SDL_PollEvent (@event) = 1
      do
         case event.type_ of
            SDL_KeyDown:
               Quitted := Quitted or (event.key.keysym.sym = LongWord ('q'));
            SDL_QuitEv: Quitted := True;
         end;
   end;
   
var
   ScreenSize : array[0..1] of Double;
   BallRad : Double;
   
   procedure Main;
   var
      R, V, NR : Tvector2_double;
      i : Integer;
   begin
      R.Init (0.48 * screen^.w / 2, 0.86 * screen^.h / 2);
      V.Init (0.007 * screen^.w / 2, 0.011 * screen^.h / 2);
      repeat
         {I like it better with one-step shadow...}
         NR := R - BallRad;
         DrawBallOrShadow (True, Round (NR.data[0]), Round (NR.data[1]));
         
         NR := R + V;
         for i := 0 to 1 do
            if (NR.data[i] - BallRad < 0)
               or (NR.data[i] + BallRad >= ScreenSize[i])
            then V.data[i] := -V.data[i];         
         R := R + V;
         
         NR := R - BallRad;
         DrawBallOrShadow (False, Round (NR.data[0]), Round (NR.data[1]));
         
         SDL_Flip (screen);
         SDL_Delay (10)
      until Quitted;
   end;
   
begin
   WriteLn ('Initializing SDL.');
   if SDL_Init(SDL_INIT_VIDEO) < 0
   then begin
      WriteLn ('Couldn''t initialize SDL : ', SDL_GetError);
      SDL_Quit; exit
   end;
   background := IMG_Load (BackgroundFile);
   if background = nil
   then begin
      WriteLn('Couldn''t load ', BackgroundFile, ' : ', SDL_GetError);
      SDL_Quit; exit
   end;
   ScreenSize[0] := background^.w;
   ScreenSize[1] := background^.h;
   screen := SDL_SetVideoMode(background^.w, background^.h,
                              background^.format^.BitsPerPixel,
                              SDL_HWSURFACE or SDL_DOUBLEBUF);
   if screen = nil
   then begin
      WriteLn ('Couldn''t set video mode : ', SDL_GetError);
      SDL_FreeSurface(background); SDL_Quit;
      exit
   end;
   ball := IMG_Load (BallFile);
   if ball = nil
   then begin
      WriteLn('Couldn''t load ', BallFile, ' : ', SDL_GetError);
      SDL_FreeSurface(background);
      SDL_FreeSurface(screen); SDL_Quit; exit
   end;
   BallRad := (ball^.w + ball^.h) / 4;

   if SDL_BlitSurface(background, nil, screen, nil) < 0 then
      WriteLn('BlitSurface background error : ', SDL_GetError);
   Main;
   
   SDL_FreeSurface(background);
   SDL_FreeSurface(ball);
   SDL_FreeSurface(screen);
   SDL_Quit
end.