{Move part of a BMP image bouncing from edges of the window.}
program BouncingBallSDLslides;
uses SDL;
const
   BackgroundFile = 'background.bmp';
   BallFile = 'ball.bmp';
var
   screen, background, ball : PSDL_Surface;
   
   procedure DrawBall (const pixX, pixY : Integer);
   var
      SrcRect, DstRect : SDL_Rect;
   begin
      if (pixX >= 0) and (pixY >= 0)
         and (pixX + ball^.w < screen^.w) and (pixY + ball^.h < screen^.h)
      then begin
         with SrcRect do begin
            x := 0; y := 0; w := ball^.w; h := ball^.h
         end;
         with DstRect do begin
            x := pixX; y := pixY; w := pixX + ball^.w; h := pixY + ball^.h
         end;
         SDL_BlitSurface (ball, @SrcRect, screen, @DstRect)      
      end
   end;
   
   
   function Quitted : Boolean;
   
   procedure Main;
   var rx, ry, vx, vy : Real;
   begin
      rx := 0.48 * screen^.w / 2;
      ry := 0.86 * screen^.h / 2;
      vx := 0.015 * screen^.w / 2;
      vy := 0.023 * screen^.h / 2;
      repeat
         SDL_BlitSurface(background, nil, screen, nil);
         if (rx + vx < 0) or (rx + vx >= screen^.w - ball^.w)
         then vx := -vx;
         if (ry + vy < 0) or (ry + vy >= screen^.h - ball^.h)
         then vy := -vy;
         rx := rx + vx;
         ry := ry + vy;
         DrawBall (round (rx), round (ry));
         SDL_Flip (screen);
         SDL_Delay (20)
      until Quitted;
   end;
   
   function Quitted : Boolean;
   var event : TSDL_Event;
   begin
      Quitted := False;
      while SDL_PollEvent (@event) = 1
      do
         case event.type_ of
            SDL_KeyDown:
               Quitted := Quitted or (event.key.keysym.sym = LongWord ('q'));
            SDL_QuitEv: Quitted := True;
         end;
   end;

begin
   SDL_Init(SDL_INIT_VIDEO);
   background := SDL_LoadBMP (BackgroundFile);
   screen := SDL_SetVideoMode(background^.w, background^.h,
                              background^.format^.BitsPerPixel,
                              SDL_HWSURFACE or SDL_DOUBLEBUF);
   ball := SDL_LoadBMP (BallFile);
   SDL_SetAlpha(ball, SDL_SRCALPHA, SDL_ALPHA_OPAQUE);
   ball^.format^.Amask := $FF000000;
   ball^.format^.Ashift := 24;
   Main;
   SDL_FreeSurface(background);
   SDL_FreeSurface(ball);
   SDL_FreeSurface(screen);
   SDL_Quit
end.