{Overlay an image with transparency over a background.}
program ImageAlphaSDL2;
uses SDL, SDL_image;
const
   BackgroundFile = 'background.bmp';
   BallFile = 'ball.bmp';
   pixX = 200; pixY = 200;
var
   screen, background, ball : PSDL_Surface;
   SrcRect, DstRect : SDL_Rect;
   
begin
   WriteLn ('Initializing SDL.');
   if SDL_Init(SDL_INIT_VIDEO) < 0
   then begin
      WriteLn ('Couldn''t initialize SDL : ', SDL_GetError);
      SDL_Quit; exit
   end;
   background := IMG_Load (BackgroundFile);
   if background = nil
   then begin
      WriteLn('Couldn''t load ', BackgroundFile, ' : ', SDL_GetError);
      SDL_Quit; exit
   end;
   screen := SDL_SetVideoMode(background^.w, background^.h,
                              background^.format^.BitsPerPixel,
                              SDL_SWSURFACE);
   if screen = nil
   then begin
      WriteLn ('Couldn''t set video mode : ', SDL_GetError);
      SDL_FreeSurface(background); SDL_Quit; exit
   end;
   ball := IMG_Load (BallFile);
   if ball = nil
   then begin
      WriteLn('Couldn''t load ', BallFile, ' : ', SDL_GetError);
      SDL_FreeSurface(background); SDL_FreeSurface(screen); SDL_Quit; exit
   end;

   if SDL_BlitSurface(background, nil, screen, nil) < 0 then
      WriteLn('BlitSurface background error : ', SDL_GetError);
   with SrcRect do begin
      x := 0; y := 0; w := ball^.w; h := ball^.h
   end;
   with DstRect do begin
      x := pixX; y := pixY; w := pixX + ball^.w; h := pixY + ball^.h
   end;
   if SDL_BlitSurface (ball, @SrcRect, screen, @DstRect) < 0
   then WriteLn ('BlitSurface ball error : ', SDL_GetError);
   SDL_Flip (screen);
   
   ReadLn;
   SDL_FreeSurface(background);
   SDL_FreeSurface(ball);
   SDL_FreeSurface(screen);
   SDL_Quit
end.