{Find a Minimum Weight Spanning Tree using Prim's algorithm.
 The graph is represented by an incidence matrix storing edge weights.
 The tree is represented by associating a node with its parent node.}
program MinimumSpanningTree;
uses math;
const NumOfNodes = 10;
type Vertices = 0..NumOfNodes - 1;
const
   AllVertices : set of Vertices = [Low(Vertices)..High(Vertices)];
   DispCode : array[0..4] of Char = ('#','%','|',':','.');
var
   graph : array[Vertices, Vertices] of Real;
   visited : set of Vertices;
   SpanningTree : array[Vertices] of Vertices;
   i, j, MinSrc, MinDest : Integer;
   MinWeight : Real;
begin
   {Initialize the graph.}
   for i in Vertices do
      for j in Vertices do
         if i < j
         then begin
            if random > 0.5
            then graph[i, j] := random
            else graph[i, j] := Infinity
         end else if i = j
         then graph[i, j] := Infinity
         else graph[i, j] := graph[j, i];
   
   {Display the graph.}
   for i in Vertices do
   begin
      WriteLn;
      for j in Vertices do
         if graph[i, j] < 1
         then Write (DispCode[Trunc(graph[i, j] * Length (DispCode))])
         else Write (' ');
   end;
   WriteLn;
   
   {Compute the result.}
   for i in Vertices do
      SpanningTree[i] := i;
   visited := [0];
   MinWeight := 0;
   while (MinWeight <> Infinity) and not (AllVertices <= visited) do
   begin
      {Find the minimum edge to unvisited part.}
      MinWeight := Infinity;
      for i in visited do
         for j in AllVertices - visited do
            if graph[i, j] < MinWeight
            then begin
               MinWeight := graph[i, j];
               MinSrc := i; MinDest := j
            end;
      SpanningTree[MinDest] := MinSrc;
      Include (visited, MinDest)
   end;
      
   {Display the result.}
   for i in Vertices do
   begin
      WriteLn;
      for j in Vertices do
         if (SpanningTree[i] = j) or (SpanningTree[j] = i)
         then Write ('*') else Write (' ');
   end;
   WriteLn
end.