program SelfAvoidingWalk;
var
   N : Integer;              {Size of the board.}
   A : array of array of Boolean;    {The board.}
   DeadEnds : Integer; {Counting dead-end walks.}
   
   procedure Initialize;
   var x, y : Integer;
   begin
      for x := 0 to N-1 do
         for y := 0 to N-1 do
            A[x,y] := false;
   end;
   
   procedure RandomWalk;
   var
      x, y : Integer;
      DeadEnd : Boolean;
      r : Real;
   begin
      Initialize;
      x := N div 2; y := N div 2;
      DeadEnd := false;
      while not DeadEnd
            and (x > 0) and (x < N-1) and (y > 0) and (y < N-1) do
      begin
         A[x,y] := true;
         {Check for dead end and make a random move.}
         if A[x-1,y] and A[x+1,y] and A[x,y-1] and A[x,y+1] then
         begin
            Inc (DeadEnds); DeadEnd := true
         end else begin
            r := random;
            if      r < 0.25 then begin if not A[x+1,y] then Inc(x); end
            else if r < 0.50 then begin if not A[x-1,y] then Dec(x); end
            else if r < 0.75 then begin if not A[x,y+1] then Inc(y); end
            else if r < 1.00 then begin if not A[x,y-1] then Dec(y); end
         end
      end
   end;
   
var
   walk, T : Integer;
   ParseCode : Word;
   
begin
   Val (ParamStr (1), N, ParseCode); if ParseCode <> 0 then exit;
   Val (ParamStr (2), T, ParseCode); if ParseCode <> 0 then exit;
   SetLength (A, N, N);
   Randomize;
   DeadEnds := 0;
   for walk := 1 to T do RandomWalk;
   WriteLn ((100*DeadEnds) div T, '% dead ends')
end.